// SPDX-License-Identifier: Unlicense
pragma solidity ^0.8.24;

import {ERC20} from "@openzeppelin/contracts/token/ERC20/ERC20.sol";
import "./Reputation.sol";
import "./ValidationPools.sol";
import "./Forum.sol";
import "../interfaces/IAcceptAvailability.sol";

contract DAO is Reputation, Forum, ValidationPools {
    // constructor(DAO importFrom) {
    //     if (address(importFrom) != address(0)) {
    //         for (uint i = 0; i < importFrom.memberCount(); i++) {
    //             members[i] = importFrom.members(i);
    //             isMember[members[i]] = true;
    //             _mint(members[i], importFrom.balanceOf(members[i]));
    //         }
    //         for (uint i = 0; i < importFrom.postCount(); i++) {
    //             string memory postId = importFrom.postIds(i);
    //             Post memory post = importFrom.posts(postId);
    //         }
    //     }
    // }

    /// Authorize a contract to transfer REP, and call that contract's acceptAvailability method
    function stakeAvailability(
        address to,
        uint256 value,
        uint duration
    ) external returns (bool) {
        _approve(msg.sender, to, allowance(msg.sender, to) + value);
        IAcceptAvailability(to).acceptAvailability(msg.sender, value, duration);
        return true;
    }
}

/// Convenience contract to extend for other contracts that will be initialized to
/// interact with a DAO contract.
contract DAOContract {
    DAO immutable dao;

    constructor(DAO dao_) {
        dao = dao_;
    }
}
