const deployContract = require('./util/deploy-contract');
const deployDAOContract = require('./util/deploy-dao-contract');
const deployWorkContract = require('./util/deploy-work-contract');
const deployRollableWorkContract = require('./util/deploy-rollable-work-contract');

async function main() {
  await deployContract('DAO', [], true);
  await deployDAOContract('Rollup');
  await deployDAOContract('Proposals');
  await deployWorkContract('Work1');
  await deployWorkContract('Onboarding');
  await deployRollableWorkContract('Work2');
}

main().catch((error) => {
  console.error(error);
  process.exitCode = 1;
});
